<?php
/************************************************************************/
/* DUNE by NPDS                                                         */
/* ===========================                                          */
/* From Glossaire version 1.3 pour myPHPNuke 1.8                        */
/* Copyright  2001, Pascal Le Boustouller                              */
/* webmaster@i-annonces.net - http://www.i-annonces.net                 */
/*                                                                      */
/* This version name NPDS Copyright (c) 2001-2008 by Philippe Brunier   */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/
if (!function_exists("Mysql_Connexion")) {
   include ("mainfile.php");
}

// Retro compatibilit SABLE
if (!function_exists("sql_connect")) {
   include ("modules/$ModPath/retro-compat/mysql.php");
}
// Retro compatibilit SABLE

include ("modules/$ModPath/glossaire.conf.php");
include ("modules/$ModPath/lang/glossaire.$language.php");
include ("modules/$ModPath/cache.timings.php");

function glohead() {
   global $ModPath, $ModStart, $activ_rech, $NPDS_Prefix;

   include ("modules/$ModPath/retro-compat/pages.php");
   include("header.php");
   OpenTable();
   echo "<table width=\"100%\" cellspacing=\"2\" cellpadding=\"2\" border=\"0\"><tr><td class=\"header\">\n";
   echo glo_translate("Glossaire");
   echo "</td></tr></table>\n";
   echo "<br />\n";
   
   $acounter = sql_query("SELECT count(*) FROM ".$NPDS_Prefix."td_glossaire WHERE affiche!='0'");
   list($acount) = sql_fetch_row($acounter);
   if($acount == 0) {
     echo "<p align=\"center\" class=\"rouge\">".glo_translate("La base est vide")."</p>";
   } else {
     echo "<table width=\"100%\" cellspacing=\"2\" cellpadding=\"2\" border=\"0\"><tr><td align=\"center\">\n";
     tlist($acount);
     echo "</td></tr></table>\n";
     if ($activ_rech) {
        aff_forme_rech();
     }
     echo "<hr noshade=\"noshade\" class=\"ongl\" />";
     aff_alpha("rien");
   }
   CloseTable();
}

function glofoot() {
   global $ModPath, $ModStart, $ok_submit, $NPDS_Prefix;

   if ($ok_submit) {
      OpenTable();
      echo "<table width=\"100%\" cellspacing=\"2\" cellpadding=\"2\" border=\"0\"><tr><td class=\"header\">\n";
      echo glo_translate("Soumettre une dfinition");
      echo "</td></tr></table>\n";
      echo "<form action=\"modules.php?ModPath=$ModPath&ModStart=$ModStart\" method=\"POST\" name=\"adminForm\">\n<table width=\"100%\" cellspacing=\"0\" cellpadding=\"2\" border=\"0\">\n";
      echo "<tr><td width=\"15%\"><b>".glo_translate("Terme")." :</b></td><td><input class=\"textbox_standard\" type=\"text\" name=\"terme\" size=\"45\" maxsize=\"100\" /></td></tr>\n";
      echo "<tr><td width=\"15%\"><b>".glo_translate("Catgorie")." :</b></td><td><input class=\"textbox_standard\" type=\"text\" name=\"gcategory\" size=\"25\" maxlength=\"30\" /> - \n";

      echo "<select class=\"textbox_standard\" name=\"sgcategory\">";
      $result = sql_query("SELECT DISTINCT gcat FROM ".$NPDS_Prefix."td_glossaire ORDER BY gcat");
      while (list($dcategory) = sql_fetch_row($result)) {
         $dcategory=stripslashes($dcategory);
         echo "<option $sel value=\"$dcategory\">$dcategory</option>\n";
      }
      echo "</select></td></tr>\n";

      echo "<tr><td width=\"15%\"><b>".glo_translate("Dfinition")." :</b></td><td><textarea name=\"content\" class=\"textbox\" style=\"width: 100%;\" wrap=\"virtual\" cols=\"45\" rows=\"15\"></textarea>";
         echo aff_editeur("content", "true");
      echo "</td></tr>\n";
      echo "<tr><td width=\"15%\"><b>".translate("Web Links")." : </b></td><td><input class=\"textbox\" type=\"text\" name=\"xurl\" size=\"45\" maxsize=\"255\" /> (http://...)</td></tr>\n";
      echo "<input type=\"hidden\" name=\"op\" value=\"submit_terme\" />";
      echo "<tr><td colspan=\"2\" align=\"center\">".Q_spambot()." <input class=\"bouton_standard\" type=\"submit\" value=\"".translate("Submit")."\" />\n";
      echo "</td></tr></table></form>\n";
      CloseTable();
   }
   include ("footer.php");
}

function rand_glo() {
   global $nb_affichage, $NPDS_Prefix;

   $acounter = sql_query("SELECT count(*) FROM ".$NPDS_Prefix."td_glossaire WHERE affiche!='0'");
   list($acount) = sql_fetch_row($acounter);
   if ($acount != 0) {
      OpenTable();
      echo "<table width=\"100%\" cellspacing=\"2\" cellpadding=\"2\" border=\"0\"><tr><td class=\"header\">\n";
      echo glo_translate("Quelques dfinitions");
      echo "</td></tr></table>\n";
      echo "<br />";
      echo "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"2\" border=\"0\">\n";
      settype($nb_affichage,"integer");
      $TableRep=sql_query("SELECT id, nom, definition, lien FROM ".$NPDS_Prefix."td_glossaire WHERE affiche!='0' ORDER BY RAND() LIMIT $nb_affichage");
      while (list($id_terme,$terme,$terme_def, $terme_lien) = sql_fetch_row($TableRep)) {
         $rowcolor = tablos();
         echo "<tr $rowcolor><td align=\"left\" valign=\"top\" width=\"20%\"><b>$terme</b></td><td align=\"left\">$terme_def </td>";
         if ($terme_lien) {
            echo "<tr $rowcolor><td colspan=\"2\">".translate("Web Links")." : <a href=\"$terme_lien\" target=\"_blank\" class=\"noir\">$terme_lien</a></td></tr>\n";
         }
         echo "<tr><td colspan=\"2\">&nbsp;</td></tr>";
      }
      echo "</table>";
      CloseTable();
   }      
}

function categ_glo($gcat, $debut) {
   global $ModPath, $ModStart, $SuperCache, $nb_affichage, $NPDS_Prefix;

   $cate = removeHack(StripSlashes(strip_tags(urldecode($gcat), ENT_NOQUOTES)));
   settype($debut,"integer");
   if ($debut=="") { $debut=0; }

   $TableRep=sql_query("SELECT id FROM ".$NPDS_Prefix."td_glossaire WHERE affiche!='0' AND gcat='$cate' ORDER BY nom");
   $nbe=sql_num_rows($TableRep);
   
   // Include cache manager
   if ($SuperCache) {
      $cache_obj = new cacheManager();
      $cache_obj->startCachingPage();
   }
   if (($cache_obj->genereting_output==1) or ($cache_obj->genereting_output==-1) or (!$SuperCache)) {
      OpenTable();
      settype($nb_affichage,"integer");
      $TableRep=sql_query("SELECT id, nom, definition, lien FROM ".$NPDS_Prefix."td_glossaire WHERE affiche!='0' AND gcat='$cate' ORDER BY nom LIMIT $debut,$nb_affichage");
      $top=1;
      $topsuivant="modules.php?ModPath=$ModPath&amp;ModStart=$ModStart&amp;gcat=$cate";

      if ($top==1) {
         echo "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"2\" border=\"0\">\n";
         echo "<tr><td class=\"ongl\" colspan=\"2\"><span class=\"rouge\">$nbe</span> ".glo_translate("Rponse(s)")."</td></tr>\n";
         while (list($glo_id, $glo_nom, $glo_definition, $glo_lien)=sql_fetch_row($TableRep)) {
            $rowcolor = tablos();
            echo "<tr $rowcolor><td align=\"left\" valign=\"top\" width=\"20%\"><b>$glo_nom</b></td><td align=\"left\">$glo_definition </td>";
            echo "</td></tr>\n";
            if ($glo_lien) {
               echo "<tr $rowcolor><td colspan=\"2\">".translate("Web Links")." : <a href=\"$glo_lien\" target=\"_blank\" class=\"noir\">$glo_lien</a></td></tr>\n";
            }
            echo "<tr><td colspan=\"2\">&nbsp;</td></tr>";
         }
         echo "</table>\n\n";
      }
      pagination ($top, $debut, $topsuivant, $nb_affichage, $nbe);
      CloseTable();
   }
   if ($SuperCache) {
      $cache_obj->endCachingPage();
   }
}

function rech_lettre($lettre, $gcat, $debut) {
   global $ModPath, $ModStart, $SuperCache, $nb_affichage, $NPDS_Prefix;

   $lettre = removeHack(StripSlashes(strip_tags(urldecode($lettre), ENT_NOQUOTES)));
   if (empty($gcat)) { $cate = translate("All"); } else { $cate = removeHack(StripSlashes(strip_tags(urldecode($gcat), ENT_NOQUOTES))); }
   settype($debut,"integer");
   if ($debut=="") { $debut=0; }

   $TableRep=sql_query("SELECT id FROM ".$NPDS_Prefix."td_glossaire WHERE affiche!='0' AND lettre='$lettre'".($cate!=translate("All")?" AND gcat='$cate'":"")." ORDER BY nom");
   $nbe=sql_num_rows($TableRep);
   // Include cache manager
   if ($SuperCache) {
      $cache_obj = new cacheManager();
      $cache_obj->startCachingPage();
   }
   if (($cache_obj->genereting_output==1) or ($cache_obj->genereting_output==-1) or (!$SuperCache)) {
      OpenTable();
      settype($nb_affichage,"integer");
      $TableRep=sql_query("SELECT id, nom, definition, lien FROM ".$NPDS_Prefix."td_glossaire WHERE affiche!='0' AND lettre='$lettre'".($cate!=translate("All")?" AND gcat='$cate'":"")." ORDER BY nom LIMIT $debut,$nb_affichage");
      $top=1;
      $topsuivant="modules.php?ModPath=$ModPath&amp;ModStart=$ModStart&amp;gcat=$cate&amp;op=rech_lettre&amp;lettre=$lettre";

      if ($top==1) {
         echo "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"2\" border=\"0\">\n";
         echo "<tr><td class=\"ongl\" colspan=\"2\"><span class=\"rouge\">$nbe</span> ".glo_translate("Rponse(s)")."</td></tr>\n";
         while (list($glo_id, $glo_nom, $glo_definition, $glo_lien)=sql_fetch_row($TableRep)) {
            $rowcolor = tablos();
            echo "<tr $rowcolor><td align=\"left\" valign=\"top\" width=\"20%\"><b>$glo_nom</b></td><td align=\"left\">$glo_definition </td>";
            echo "</td></tr>\n";
            if ($glo_lien) {
               echo "<tr $rowcolor><td colspan=\"2\">".translate("Web Links")." : <a href=\"$glo_lien\" target=\"_blank\" class=\"noir\">$glo_lien</a></td></tr>\n";
            }
            echo "<tr><td colspan=\"2\">&nbsp;</td></tr>";
         }
        echo "</table>\n\n";
      }
      pagination ($top, $debut, $topsuivant, $nb_affichage, $nbe);
      CloseTable();
   }
   if ($SuperCache) {
      $cache_obj->endCachingPage();
   }
}

function rech_terme($type, $terme, $debut) {
   global $ModPath, $ModStart, $SuperCache, $nb_affichage, $NPDS_Prefix;

   settype($type, "integer");
   $query=removeHack(StripSlashes(strip_tags(urldecode($terme), ENT_NOQUOTES))); // electrobug
   settype($debut,"integer");

   if ($type =="1") {
      $types = "nom LIKE '%$query%'";
   }
   if ($type =="2") {
      $types = "definition LIKE '%$query%'";
   }
   if ($type =="3") {
      $types = "nom LIKE '%$query%' OR definition LIKE '%$query%'";
   }

   if ($debut=="") { $debut=0; }
   $TableRep=sql_query("SELECT id, nom, definition, lettre FROM ".$NPDS_Prefix."td_glossaire WHERE $types AND affiche!='0' ORDER BY nom ");
   $nbe=sql_num_rows($TableRep);
   // Include cache manager
   if ($SuperCache) {
      $cache_obj = new cacheManager();
      $cache_obj->startCachingPage();
   }
   if (($cache_obj->genereting_output==1) or ($cache_obj->genereting_output==-1) or (!$SuperCache)) {
      OpenTable();
      settype($nb_affichage,"integer");
      $result = sql_query("SELECT id, nom, definition, lien FROM ".$NPDS_Prefix."td_glossaire WHERE $types AND affiche!='0' ORDER BY nom LIMIT $debut,$nb_affichage");
      $top=1;
      $topsuivant="modules.php?ModPath=$ModPath&amp;ModStart=$ModStart&amp;op=rech_terme&amp;terme=$terme&amp;type=$type";

      if ($top==1) {
         echo "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"2\" border=\"0\">\n";
         echo "<tr><td class=\"ongl\" colspan=\"2\"><span class=\"rouge\">$nbe</span> ".glo_translate("Rponse(s)")."</td></tr>\n";
         while (list($glo_id, $glo_nom, $glo_definition, $glo_lien)=sql_fetch_row($result)) {
            $rowcolor = tablos();
            echo "<tr $rowcolor><td align=\"left\" valign=\"top\" width=\"20%\"><b>$glo_nom</b></td><td align=\"left\">$glo_definition </td>";
            echo "</td></tr>\n";
            if ($glo_lien) {
               echo "<tr $rowcolor><td colspan=\"2\">".translate("Web Links")." : <a href=\"$glo_lien\" target=\"_blank\" class=\"noir\">$glo_lien</a></td></tr>\n";
            }
            echo "<tr><td colspan=\"2\">&nbsp;</td></tr>";
         }
         echo "</table>\n";
      }
      pagination ($top, $debut,$topsuivant,$nb_affichage,$nbe);
      CloseTable();
   }
   if ($SuperCache) {
      $cache_obj->endCachingPage();
   }
}

// SOUS-FONCTIONS
function tlist($acount) {
  global $ModPath, $ModStart, $sortby, $gcat, $NPDS_Prefix;
  $cate = stripslashes($gcat);
  echo "<span class=\"noir\">".translate("Select Category Folder")."</span>\n";
  echo "<table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\" class=\"titboxc\">\n";
  echo "<tr><td width=\"20%\" nowrap=\"nowrap\">\n";
  if (($cate == translate("All")) OR ($cate == "")) {
     echo "<img src=\"";
     if ($ibid=theme_image("download/folder_open.gif")) {$imgtmp=$ibid;} else {$imgtmp="images/download/folder_open.gif";}
     echo "$imgtmp\" title=\"".translate("All")." ($acount)\" alt=\"".translate("All")." ($acount)\" border=\"0\" /> <b>".translate("All")." ($acount)</b>\n";
  } else {
     echo "<a href=\"modules.php?ModPath=$ModPath&amp;ModStart=$ModStart&amp;gcat=".translate("All")."&amp;sortby=$sortby\" class=\"noir\"><img src=\"";
     if ($ibid=theme_image("download/folder.gif")) {$imgtmp=$ibid;} else {$imgtmp="images/download/folder.gif";}
     echo "$imgtmp\" title=\"".translate("All")." ($acount)\" alt=\"".translate("All")." ($acount)\" border=\"0\" /> ".translate("All")."</a> ($acount)\n";
  }
  $result = sql_query("SELECT DISTINCT gcat, count(gcat) FROM ".$NPDS_Prefix."td_glossaire WHERE affiche!='0' GROUP BY gcat ORDER BY gcat");
  echo "</td>";
  $rup=1;
  while (list($category, $dcount) = sql_fetch_row($result)) {
    $rup++;
    $category=stripslashes($category);
    echo "<td width=\"20%\" nowrap=\"nowrap\">";
    if ($category == $cate) {
        echo "<img src=\"";
        if ($ibid=theme_image("download/folder_open.gif")) {$imgtmp=$ibid;} else {$imgtmp="images/download/folder_open.gif";}
        echo "$imgtmp\" title=\"$category ($dcount)\" alt=\"$category ($dcount)\" border=\"0\" /><span class=\"noir\"> <b>$category ($dcount)</b></span> \n";
    } else {
        $category2 = urlencode($category);
        echo "<a href=\"modules.php?ModPath=$ModPath&amp;ModStart=$ModStart&amp;gcat=$category2&amp;sortby=$sortby\" class=\"noir\"><img src=\"";
        if ($ibid=theme_image("download/folder.gif")) {$imgtmp=$ibid;} else {$imgtmp="images/download/folder.gif";}
        echo "$imgtmp\" title=\"$category ($dcount)\" alt=\"$category ($dcount)\" border=\"0\" /> $category</a> ($dcount) \n";
    }
    echo "</td>";
    if ($rup>=5) {
       echo "</tr>\n<tr>";
       $rup=0;
    }
  }
  echo "</tr></table>\n";
}
function aff_forme_rech() {
   global $ModPath, $ModStart;
   echo "<hr noshade=\"noshade\" class=\"ongl\" /><form action=\"modules.php?ModPath=$ModPath&amp;ModStart=$ModStart\" method=\"post\">\n";
   echo "<p align=\"center\"><b>".translate("Search")." ".translate("by")." :</b> \n";
   echo "<select class=\"textbox_standard\" name=\"type\">\n";
   echo "<option value=\"1\"> ".glo_translate("Termes")."\n";
   echo "<option value=\"2\"> ".glo_translate("Dfinitions");
   echo "\n<option value=\"3\"> ".glo_translate("Termes")." & ".glo_translate("Dfinitions");
   echo "\n</select>\n";
   echo "<input type=\"hidden\" name=\"op\" value=\"rech_terme\" />\n";
   echo " <input class=\"textbox_standard\" type=\"text\" name=\"terme\" size=\"13\" maxsize=\"100\" /> - <input class=\"bouton_standard\" type=\"submit\" value=\"".translate("Submit")."\" />\n";
   echo "</p></form>\n";
}
function aff_alpha($type) {
   global $ModPath, $ModStart, $gcat;

   echo "<p align=\"center\">[ ";
   $alphabet = array ("A","B","C","D","E","F","G","H","I","J","K","L","M",
                      "N","O","P","Q","R","S","T","U","V","W","X","Y","Z","".translate("Other")."");
   $num = count($alphabet) - 1;
   $counter = 0;
   while (list(, $ltr) = each($alphabet)) {
      if ($ltr!=translate("Other")) {
         echo "<a href=\"modules.php?ModPath=$ModPath&amp;ModStart=$ModStart&amp;gcat=$gcat&amp;op=rech_lettre&amp;lettre=$ltr\" class=\"noir\">$ltr</a>\n";
      } else {
         echo "<a href=\"modules.php?ModPath=$ModPath&amp;ModStart=$ModStart&amp;gcat=$gcat&amp;op=rech_lettre&amp;lettre=!AZ\" class=\"noir\">$ltr</a>\n";
      }
      if ( $counter == round($num/2) )
         echo " ]<br />[ ";
      elseif ( $counter != $num )
         echo "&nbsp;|&nbsp;";
         $counter++;
   }
   echo " ]</p>\n";
}
function pagination ($top, $debut, $topsuivant, $nb_affichage, $nbe) {
   global $ModPath, $ModStart;
   if ($top==1) {
       echo "<br /><p align=\"center\">\n";
       if ($debut != 0) {
          echo "<a href=\"".$topsuivant."&debut=";
          $resultat = ($debut-$nb_affichage);
          if ($resultat < 0) {
             $resultat = 0;
          }
          if ($ibid=theme_image("download/left.gif")) {$imgtmp=$ibid;} else {$imgtmp="images/download/left.gif";}
          echo "$resultat\" class=\"noir\"><img src=".$imgtmp." border=\"0\" align=\"middle\" alt=\"\" /> ".translate("previous matches")."</a>\n";
          $deb=true;
       }
       if (($debut+$nb_affichage) < $nbe) {
          if ($deb)
             echo "|&nbsp;";
          echo "<a href=\"".$topsuivant."&debut=";
          $final =($debut+$nb_affichage);
          if ($final >= $nbe) {
             $final=($nbe - $nb_affichage);
          }
          if ($ibid=theme_image("download/right.gif")) {$imgtmp=$ibid;} else {$imgtmp="images/download/right.gif";}
          echo $final."\" class=\"noir\">".translate("next matches")." <img src=".$imgtmp." border=\"0\" align=\"middle\" alt=\"\" /></a>\n";
       }
    echo "</p>\n";
   }
}
// SWITCH AFFICHAGE PAGE
switch($op) {
   case "submit_terme":
      if (!R_spambot($asb_question, $asb_reponse, $content)) {
         header("location: modules.php?ModPath=$ModPath&ModStart=$ModStart");
         die();
      }
      global $NPDS_Prefix;
      glohead();

      if (!$gcategory) { $gcategory = $sgcategory; }

      if (($gcategory!="") and ($terme!="") and ($content!="")) {
         $lettre=substr(ucfirst($terme),0,1);
         if (!ereg("[A-Z]",$lettre)) {$lettre="!AZ";}
         $gcategory=removeHack(addslashes(strip_tags(urldecode($gcategory), ENT_NOQUOTES))); // electrobug
         $terme=removeHack(stripslashes(strip_tags(urldecode($terme), ENT_NOQUOTES))); // electrobug
         $content=removeHack($content);
         $result=sql_query("select * from ".$NPDS_Prefix."td_glossaire where gcat='$gcategory' and nom='$terme' and definition='$content'");
         list($id)=sql_fetch_row($result);
         opentable();
         if (!$id) {
            sql_query("insert into ".$NPDS_Prefix."td_glossaire values (NULL, '$gcategory', '$lettre', '$terme', '$content', '0', '$xurl')");
            echo "<p align=\"center\">".translate("Thanks for your submission.")."</p>";
         } else {
            echo "<p align=\"center\">".glo_translate("Une dfinition identique existe dj !")."</p>";
         }
         closetable();
      } else {
         opentable();
            echo "<p align=\"center\">".translate("Please enter information according to the specifications").".</p>";
         closetable();
      }
      glofoot();
      break;

   case "rech_terme":
      glohead();
      rech_terme($type, $terme, $debut);
      glofoot();
      break;

   case "rech_lettre":
      glohead();
      rech_lettre($lettre, $gcat, $debut);
      glofoot();
      break;

    default:
      glohead();
      if (empty($gcat) || (stripslashes($gcat)==translate("All"))) {
         rand_glo();
      } else {
         categ_glo($gcat, $debut);
      }
      glofoot();
      break;
}
?>